/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */


$(".view-main").on("ptr:refresh", ".ptr-content", function () {
    restartApplication();
});

function editNote(id) {
    var note = NOTES.get(id);
    router.navigate("/editnote", {
        context: {
            noteid: id,
            content: note.content,
            notetitle: note.title,
        }
    });
    console.log("Editing " + id);
}

function favoriteNote(id) {

}

function makeList(id) {

}

function deleteNote(id) {
    app.dialog.confirm('Are you sure?', 'Delete Note', function () {
        NOTES.del(id, function () {
            app.ptr.refresh();
        });
    });
}

$("#app").on("click", ".edit-note-btn", function () {
    editNote($(this).data("note"));
    app.popover.close();
});

$("#app").on("click", ".favorite-note-btn", function () {
    favoriteNote($(this).data("note"));
    app.popover.close();
});

$("#app").on("click", ".listify-note-btn", function () {
    makeList($(this).data("note"));
    app.popover.close();
});

$("#app").on("click", ".delete-note-btn", function () {
    deleteNote($(this).data("note"));
    app.popover.close();
});

function openNoteActionMenu(notecard) {
    var noteid = notecard.data("id");
    if (window.innerWidth < 768) {
        var actionsheet = app.actions.create({
            buttons: [
                {
                    text: "Edit",
                    bold: true,
                    icon: '<i class="fas fa-edit fa-fw"></i>',
                    onClick: function () {
                        editNote(noteid);
                    }
                },
//                {
//                    text: "Favorite",
//                    icon: '<i class="fas fa-star fa-fw"></i>',
//                    onClick: function () {
//                        favoriteNote(noteid);
//                    }
//                },
//                {
//                    text: "Make a List",
//                    icon: '<i class="fas fa-tasks fa-fw"></i>',
//                    onClick: function () {
//                        makeList(noteid);
//                    }
//                },
                {
                    text: "Delete",
                    icon: '<i class="fas fa-trash fa-fw"></i>',
                    onClick: function () {
                        deleteNote(noteid);
                    }
                }
            ]
        });

        actionsheet.open();
        return false;
    } else {
        var contextPopover = app.popover.create({
            targetEl: notecard.children(".menubtn"),
            content: '<div class="popover">' +
                    '<div class="popover-inner">' +
                    '<div class="list">' +
                    '<ul>' +
                    '<li><a class="list-button item-link edit-note-btn" data-note="' + noteid + '"><i class="fas fa-edit fa-fw"></i> Edit</a></li>' +
                    '<li><a class="list-button item-link favorite-note-btn" data-note="' + noteid + '"><i class="fas fa-star fa-fw"></i> Favorite</a></li>' +
                    '<li><a class="list-button item-link listify-note-btn" data-note="' + noteid + '"><i class="fas fa-tasks fa-fw"></i> Make a List</a></li>' +
                    '<li><a class="list-button item-link delete-note-btn" data-note="' + noteid + '"><i class="fas fa-trash fa-fw"></i> Delete</a></li>' +
                    '</ul>' +
                    '</div>' +
                    '</div>' +
                    '</div>'
        });
        contextPopover.open();
    }
    return false;
}

$(".view-main").on("click", ".notecard .menubtn", function () {
    return openNoteActionMenu($(this).parent());
});

$(".view-main").on("contextmenu", ".notecard", function () {
    return openNoteActionMenu($(this));
});